use mimalloc::MiMalloc;

#[global_allocator]
static GLOBAL: MiMalloc = MiMalloc;

#[cfg(test)]
mod tests {

    #[test]
    fn wont_work() {
        let alloc_size = 2 * 1024 * 1024;
        let layout = std::alloc::Layout::from_size_align(alloc_size, alloc_size).unwrap();
        let alloc = unsafe { std::alloc::alloc_zeroed(layout) };
        assert!(!alloc.is_null());
    }

    #[test]
    fn it_works() {
        let alloc_size = 2 * 1024 * 1024;
        let layout = std::alloc::Layout::from_size_align(alloc_size, alloc_size / 2).unwrap();
        let alloc = unsafe { std::alloc::alloc_zeroed(layout) };
        assert!(!alloc.is_null());
    }

    #[test]
    fn it_works2() {
        for i in 0..100000 {
            let size = 4096;
            let align = 1 << (i % 16);
            let ptr = unsafe {
                std::alloc::alloc(std::alloc::Layout::from_size_align_unchecked(size, align))
            };
            assert!(!ptr.is_null());
            assert!((ptr as usize) % align == 0, "Align {} {}", i, align);
        }
    }
}

fn main() {
    println!("Hello, world!");
}
